Subject: Re: MACVLANs really best solution? How about a bridge with multiple bridge virtual interfaces?

From: Patrick McHardy <[email-masked]>
Date: Mon, 09 Mar 2009 16:53:16 +0100

Eric W. Biederman wrote:
> There are two tricky parts.
> 
> One problem is that macvlans and the primary hardware device share the
> same transmit queue.  So when I have a broadcast packet on the primary
> devices queue I don't know if I have already sent it out to the
> macvlan devices or not.

So its about receiving packets on macvlan when transmitting on the
real device? That sounds like a really hard problem that would probably
indeed be better solved by a bridge.

If its just about whether the packet should be sent out by macvlan
to the wire as well, I'd say yes since thats what two real devices
would have done.

> The second problem is that when I transmit a multicast packet and I
> have a local listener.  I believe replicating the packet both at the
> ip layer and at the ethernet layer will result in receiving the packet
> locally twice.
> 
> I'm not certain we need to solve the second problem as having two physical
> interfaces plugged into a switch will have the same problem.

Agreed.

> The first problem is all about how do we deliver packets everywhere except self.

I think "except self should just mean "not to the originating virtual
device".